Index: LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/1DUTILS.h
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/1DUTILS.h	(revision 5102)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/1DUTILS.h	(revision 5103)
@@ -1288,205 +1275,202 @@
 
 !===============================================================
-      subroutine advect_vert(llm,w,dt,q,plev)
+subroutine advect_vert(llm, w, dt, q, plev)
+  !===============================================================
+  !   Schema amont pour l'advection verticale en 1D
+  !   w est la vitesse verticale dp/dt en Pa/s
+  !   Traitement en volumes finis
+  !   d / dt ( zm q ) = delta_z ( omega q )
+  !   d / dt ( zm ) = delta_z ( omega )
+  !   avec zm = delta_z ( p )
+  !   si * designe la valeur au pas de temps t+dt
+  !   zm*(l) q*(l) - zm(l) q(l) = w(l+1) q(l+1) - w(l) q(l)
+  !   zm*(l) -zm(l) = w(l+1) - w(l)
+  !   avec w=omega * dt
+  !---------------------------------------------------------------
+  implicit none
+  ! arguments
+  integer llm
+  real w(llm + 1), q(llm), plev(llm + 1), dt
+
+  ! local
+  integer l
+  real zwq(llm + 1), zm(llm + 1), zw(llm + 1)
+  real qold
+
+  !---------------------------------------------------------------
+
+  do l = 1, llm
+    zw(l) = dt * w(l)
+    zm(l) = plev(l) - plev(l + 1)
+    zwq(l) = q(l) * zw(l)
+  enddo
+  zwq(llm + 1) = 0.
+  zw(llm + 1) = 0.
+
+  do l = 1, llm
+    qold = q(l)
+    q(l) = (q(l) * zm(l) + zwq(l + 1) - zwq(l)) / (zm(l) + zw(l + 1) - zw(l))
+    PRINT*, 'ADV Q ', zm(l), zw(l), zwq(l), qold, q(l)
+  enddo
+
+  return
+end
+
 !===============================================================
-!   Schema amont pour l'advection verticale en 1D
-!   w est la vitesse verticale dp/dt en Pa/s
-!   Traitement en volumes finis 
-!   d / dt ( zm q ) = delta_z ( omega q )
-!   d / dt ( zm ) = delta_z ( omega )
-!   avec zm = delta_z ( p )
-!   si * designe la valeur au pas de temps t+dt
-!   zm*(l) q*(l) - zm(l) q(l) = w(l+1) q(l+1) - w(l) q(l)
-!   zm*(l) -zm(l) = w(l+1) - w(l)
-!   avec w=omega * dt
-!---------------------------------------------------------------
-      implicit none
-! arguments
-      integer llm
-      real w(llm+1),q(llm),plev(llm+1),dt
-
-! local
-      integer l
-      real zwq(llm+1),zm(llm+1),zw(llm+1)
-      real qold
-
-!---------------------------------------------------------------
-
-      do l=1,llm
-         zw(l)=dt*w(l)
-         zm(l)=plev(l)-plev(l+1)
-         zwq(l)=q(l)*zw(l)
-      enddo
-      zwq(llm+1)=0.
-      zw(llm+1)=0.
- 
-      do l=1,llm
-         qold=q(l)
-         q(l)=(q(l)*zm(l)+zwq(l+1)-zwq(l))/(zm(l)+zw(l+1)-zw(l))
-         print*,'ADV Q ',zm(l),zw(l),zwq(l),qold,q(l)
-      enddo
-
- 
-      return
-      end
-
-!===============================================================
-
-
-       SUBROUTINE advect_va(llm,omega,d_t_va,d_q_va,d_u_va,d_v_va,              &
-     &                q,temp,u,v,play)
-!itlmd 
-!----------------------------------------------------------------------
-!   Calcul de l'advection verticale (ascendance et subsidence) de 
-!   temperature et d'humidite. Hypothese : ce qui rentre de l'exterieur
-!   a les memes caracteristiques que l'air de la colonne 1D (WTG) ou 
-!   sans WTG rajouter une advection horizontale 
-!----------------------------------------------------------------------  
-        implicit none
-#include "YOMCST.h"
-!        argument
-        integer llm
-        real  omega(llm+1),d_t_va(llm), d_q_va(llm,3)
-        real  d_u_va(llm), d_v_va(llm)
-        real  q(llm,3),temp(llm)
-        real  u(llm),v(llm)
-        real  play(llm)
-! interne
-        integer l
-        real alpha,omgdown,omgup
-
-      do l= 1,llm
-       if(l.eq.1) then
-!si omgup pour la couche 1, alors tendance nulle
-        omgdown=max(omega(2),0.0)
-        alpha = rkappa*temp(l)*(1.+q(l,1)*rv/rd)/(play(l)*(1.+q(l,1)))
-        d_t_va(l)= alpha*(omgdown)-omgdown*(temp(l)-temp(l+1))             &
-     &       /(play(l)-play(l+1))
-
-        d_q_va(l,:)= -omgdown*(q(l,:)-q(l+1,:))/(play(l)-play(l+1))              
-
-        d_u_va(l)= -omgdown*(u(l)-u(l+1))/(play(l)-play(l+1))              
-        d_v_va(l)= -omgdown*(v(l)-v(l+1))/(play(l)-play(l+1))              
-
-        
-       elseif(l.eq.llm) then
-        omgup=min(omega(l),0.0)
-        alpha = rkappa*temp(l)*(1.+q(l,1)*rv/rd)/(play(l)*(1.+q(l,1)))
-        d_t_va(l)= alpha*(omgup)-                                          &
-
-!bug?     &              omgup*(temp(l-1)-temp(l))/(play(l-1)-plev(l))
-     &              omgup*(temp(l-1)-temp(l))/(play(l-1)-play(l))
-        d_q_va(l,:)= -omgup*(q(l-1,:)-q(l,:))/(play(l-1)-play(l))
-        d_u_va(l)= -omgup*(u(l-1)-u(l))/(play(l-1)-play(l))
-        d_v_va(l)= -omgup*(v(l-1)-v(l))/(play(l-1)-play(l))
-       
-       else
-        omgup=min(omega(l),0.0)
-        omgdown=max(omega(l+1),0.0)
-        alpha = rkappa*temp(l)*(1.+q(l,1)*rv/rd)/(play(l)*(1.+q(l,1)))
-        d_t_va(l)= alpha*(omgup+omgdown)-omgdown*(temp(l)-temp(l+1))       &
-     &              /(play(l)-play(l+1))-                                  &
-!bug?     &              omgup*(temp(l-1)-temp(l))/(play(l-1)-plev(l))
-     &              omgup*(temp(l-1)-temp(l))/(play(l-1)-play(l))
-!      print*, '  ??? '
-
-        d_q_va(l,:)= -omgdown*(q(l,:)-q(l+1,:))                            &
-     &              /(play(l)-play(l+1))-                                  &
-     &              omgup*(q(l-1,:)-q(l,:))/(play(l-1)-play(l)) 
-        d_u_va(l)= -omgdown*(u(l)-u(l+1))                                  &
-     &              /(play(l)-play(l+1))-                                  &
-     &              omgup*(u(l-1)-u(l))/(play(l-1)-play(l)) 
-        d_v_va(l)= -omgdown*(v(l)-v(l+1))                                  &
-     &              /(play(l)-play(l+1))-                                  &
-     &              omgup*(v(l-1)-v(l))/(play(l-1)-play(l))
-       
-      endif
-         
-      enddo
-!fin itlmd
-        return
-        end
+
+
+SUBROUTINE advect_va(llm, omega, d_t_va, d_q_va, d_u_va, d_v_va, &
+        &                q, temp, u, v, play)
+  !itlmd
+  !----------------------------------------------------------------------
+  !   Calcul de l'advection verticale (ascendance et subsidence) de
+  !   temperature et d'humidite. Hypothese : ce qui rentre de l'exterieur
+  !   a les memes caracteristiques que l'air de la colonne 1D (WTG) ou
+  !   sans WTG rajouter une advection horizontale
+  !----------------------------------------------------------------------
+  implicit none
+  include "YOMCST.h"
+  !        argument
+  integer llm
+  real  omega(llm + 1), d_t_va(llm), d_q_va(llm, 3)
+  real  d_u_va(llm), d_v_va(llm)
+  real  q(llm, 3), temp(llm)
+  real  u(llm), v(llm)
+  real  play(llm)
+  ! interne
+  integer l
+  real alpha, omgdown, omgup
+
+  do l = 1, llm
+    if(l==1) then
+      !si omgup pour la couche 1, alors tendance nulle
+      omgdown = max(omega(2), 0.0)
+      alpha = rkappa * temp(l) * (1. + q(l, 1) * rv / rd) / (play(l) * (1. + q(l, 1)))
+      d_t_va(l) = alpha * (omgdown) - omgdown * (temp(l) - temp(l + 1))             &
+              & / (play(l) - play(l + 1))
+
+      d_q_va(l, :) = -omgdown * (q(l, :) - q(l + 1, :)) / (play(l) - play(l + 1))
+
+      d_u_va(l) = -omgdown * (u(l) - u(l + 1)) / (play(l) - play(l + 1))
+      d_v_va(l) = -omgdown * (v(l) - v(l + 1)) / (play(l) - play(l + 1))
+
+    elseif(l==llm) then
+      omgup = min(omega(l), 0.0)
+      alpha = rkappa * temp(l) * (1. + q(l, 1) * rv / rd) / (play(l) * (1. + q(l, 1)))
+      d_t_va(l) = alpha * (omgup) - &
+
+              !bug?     &              omgup*(temp(l-1)-temp(l))/(play(l-1)-plev(l))
+              &              omgup * (temp(l - 1) - temp(l)) / (play(l - 1) - play(l))
+      d_q_va(l, :) = -omgup * (q(l - 1, :) - q(l, :)) / (play(l - 1) - play(l))
+      d_u_va(l) = -omgup * (u(l - 1) - u(l)) / (play(l - 1) - play(l))
+      d_v_va(l) = -omgup * (v(l - 1) - v(l)) / (play(l - 1) - play(l))
+
+    else
+      omgup = min(omega(l), 0.0)
+      omgdown = max(omega(l + 1), 0.0)
+      alpha = rkappa * temp(l) * (1. + q(l, 1) * rv / rd) / (play(l) * (1. + q(l, 1)))
+      d_t_va(l) = alpha * (omgup + omgdown) - omgdown * (temp(l) - temp(l + 1))       &
+              & / (play(l) - play(l + 1)) - &
+              !bug?     &              omgup*(temp(l-1)-temp(l))/(play(l-1)-plev(l))
+              &              omgup * (temp(l - 1) - temp(l)) / (play(l - 1) - play(l))
+      !      PRINT*, '  ??? '
+
+      d_q_va(l, :) = -omgdown * (q(l, :) - q(l + 1, :))                            &
+              & / (play(l) - play(l + 1)) - &
+              &              omgup * (q(l - 1, :) - q(l, :)) / (play(l - 1) - play(l))
+      d_u_va(l) = -omgdown * (u(l) - u(l + 1))                                  &
+              & / (play(l) - play(l + 1)) - &
+              &              omgup * (u(l - 1) - u(l)) / (play(l - 1) - play(l))
+      d_v_va(l) = -omgdown * (v(l) - v(l + 1))                                  &
+              & / (play(l) - play(l + 1)) - &
+              &              omgup * (v(l - 1) - v(l)) / (play(l - 1) - play(l))
+
+    endif
+
+  enddo
+  !fin itlmd
+  return
+end
 !       SUBROUTINE lstendH(llm,omega,d_t_va,d_q_va,d_u_va,d_v_va,
-       SUBROUTINE lstendH(llm,nqtot,omega,d_t_va,d_q_va,                        &
-     &                q,temp,u,v,play)
-!itlmd 
-!----------------------------------------------------------------------
-!   Calcul de l'advection verticale (ascendance et subsidence) de 
-!   temperature et d'humidite. Hypothese : ce qui rentre de l'exterieur
-!   a les memes caracteristiques que l'air de la colonne 1D (WTG) ou 
-!   sans WTG rajouter une advection horizontale 
-!----------------------------------------------------------------------  
-        implicit none
-#include "YOMCST.h"
-!        argument
-        integer llm,nqtot
-        real  omega(llm+1),d_t_va(llm), d_q_va(llm,nqtot)
-!        real  d_u_va(llm), d_v_va(llm)
-        real  q(llm,nqtot),temp(llm)
-        real  u(llm),v(llm)
-        real  play(llm)
-        real cor(llm)
-!        real dph(llm),dudp(llm),dvdp(llm),dqdp(llm),dtdp(llm)
-        real dph(llm),dqdp(llm),dtdp(llm)
-! interne
-        integer k
-        real omdn,omup
-
-!        dudp=0.
-!        dvdp=0.
-        dqdp=0.
-        dtdp=0.
-!        d_u_va=0.
-!        d_v_va=0.
-
-      cor(:) = rkappa*temp*(1.+q(:,1)*rv/rd)/(play*(1.+q(:,1)))
-
-
-      do k=2,llm-1
-
-       dph  (k-1) = (play(k  )- play(k-1  ))
-!       dudp (k-1) = (u   (k  )- u   (k-1  ))/dph(k-1)
-!       dvdp (k-1) = (v   (k  )- v   (k-1  ))/dph(k-1)
-       dqdp (k-1) = (q   (k,1)- q   (k-1,1))/dph(k-1)
-       dtdp (k-1) = (temp(k  )- temp(k-1  ))/dph(k-1)
-
-      enddo
-
-!      dudp (  llm  ) = dudp ( llm-1 )
-!      dvdp (  llm  ) = dvdp ( llm-1 )
-      dqdp (  llm  ) = dqdp ( llm-1 )
-      dtdp (  llm  ) = dtdp ( llm-1 )
-
-      do k=2,llm-1
-      omdn=max(0.0,omega(k+1))
-      omup=min(0.0,omega( k ))
-
-!      d_u_va(k)  = -omdn*dudp(k)-omup*dudp(k-1)
-!      d_v_va(k)  = -omdn*dvdp(k)-omup*dvdp(k-1)
-      d_q_va(k,1)= -omdn*dqdp(k)-omup*dqdp(k-1)
-      d_t_va(k)  = -omdn*dtdp(k)-omup*dtdp(k-1)+(omup+omdn)*cor(k)
-      enddo
-
-      omdn=max(0.0,omega( 2 ))
-      omup=min(0.0,omega(llm))
-!      d_u_va( 1 )   = -omdn*dudp( 1 )
-!      d_u_va(llm)   = -omup*dudp(llm)
-!      d_v_va( 1 )   = -omdn*dvdp( 1 )
-!      d_v_va(llm)   = -omup*dvdp(llm)
-      d_q_va( 1 ,1) = -omdn*dqdp( 1 )
-      d_q_va(llm,1) = -omup*dqdp(llm)
-      d_t_va( 1 )   = -omdn*dtdp( 1 )+omdn*cor( 1 )
-      d_t_va(llm)   = -omup*dtdp(llm)!+omup*cor(llm)
-
-!      if(abs(rlat(1))>10.) then
-!     Calculate the tendency due agestrophic motions
-!      du_age = fcoriolis*(v-vg)
-!      dv_age = fcoriolis*(ug-u)
-!      endif
-
-!       CALL writefield_phy('d_t_va',d_t_va,llm)
-
-          return
-         end
+SUBROUTINE lstendH(llm, nqtot, omega, d_t_va, d_q_va, &
+        &                q, temp, u, v, play)
+  !itlmd
+  !----------------------------------------------------------------------
+  !   Calcul de l'advection verticale (ascendance et subsidence) de
+  !   temperature et d'humidite. Hypothese : ce qui rentre de l'exterieur
+  !   a les memes caracteristiques que l'air de la colonne 1D (WTG) ou
+  !   sans WTG rajouter une advection horizontale
+  !----------------------------------------------------------------------
+  implicit none
+  include "YOMCST.h"
+  !        argument
+  integer llm, nqtot
+  real  omega(llm + 1), d_t_va(llm), d_q_va(llm, nqtot)
+  !        real  d_u_va(llm), d_v_va(llm)
+  real  q(llm, nqtot), temp(llm)
+  real  u(llm), v(llm)
+  real  play(llm)
+  real cor(llm)
+  !        real dph(llm),dudp(llm),dvdp(llm),dqdp(llm),dtdp(llm)
+  real dph(llm), dqdp(llm), dtdp(llm)
+  ! interne
+  integer k
+  real omdn, omup
+
+  !        dudp=0.
+  !        dvdp=0.
+  dqdp = 0.
+  dtdp = 0.
+  !        d_u_va=0.
+  !        d_v_va=0.
+
+  cor(:) = rkappa * temp * (1. + q(:, 1) * rv / rd) / (play * (1. + q(:, 1)))
+
+  do k = 2, llm - 1
+
+    dph  (k - 1) = (play(k) - play(k - 1))
+    !       dudp (k-1) = (u   (k  )- u   (k-1  ))/dph(k-1)
+    !       dvdp (k-1) = (v   (k  )- v   (k-1  ))/dph(k-1)
+    dqdp (k - 1) = (q   (k, 1) - q   (k - 1, 1)) / dph(k - 1)
+    dtdp (k - 1) = (temp(k) - temp(k - 1)) / dph(k - 1)
+
+  enddo
+
+  !      dudp (  llm  ) = dudp ( llm-1 )
+  !      dvdp (  llm  ) = dvdp ( llm-1 )
+  dqdp (llm) = dqdp (llm - 1)
+  dtdp (llm) = dtdp (llm - 1)
+
+  do k = 2, llm - 1
+    omdn = max(0.0, omega(k + 1))
+    omup = min(0.0, omega(k))
+
+    !      d_u_va(k)  = -omdn*dudp(k)-omup*dudp(k-1)
+    !      d_v_va(k)  = -omdn*dvdp(k)-omup*dvdp(k-1)
+    d_q_va(k, 1) = -omdn * dqdp(k) - omup * dqdp(k - 1)
+    d_t_va(k) = -omdn * dtdp(k) - omup * dtdp(k - 1) + (omup + omdn) * cor(k)
+  enddo
+
+  omdn = max(0.0, omega(2))
+  omup = min(0.0, omega(llm))
+  !      d_u_va( 1 )   = -omdn*dudp( 1 )
+  !      d_u_va(llm)   = -omup*dudp(llm)
+  !      d_v_va( 1 )   = -omdn*dvdp( 1 )
+  !      d_v_va(llm)   = -omup*dvdp(llm)
+  d_q_va(1, 1) = -omdn * dqdp(1)
+  d_q_va(llm, 1) = -omup * dqdp(llm)
+  d_t_va(1) = -omdn * dtdp(1) + omdn * cor(1)
+  d_t_va(llm) = -omup * dtdp(llm)!+omup*cor(llm)
+
+  !      if(abs(rlat(1))>10.) then
+  !     Calculate the tendency due agestrophic motions
+  !      du_age = fcoriolis*(v-vg)
+  !      dv_age = fcoriolis*(ug-u)
+  !      endif
+
+  !       CALL writefield_phy('d_t_va',d_t_va,llm)
+
+  return
+end
 
 !======================================================================
